Index: src/mlx/gui/faultexplain.py
===================================================================
--- src/mlx/gui/faultexplain.py	(revision 842)
+++ src/mlx/gui/faultexplain.py	(revision 999)
@@ -19,5 +19,5 @@
 #-------------------------------------------------------------------------------
 
-class FaultFrame(gtk.Frame):
+class FaultFrame(Gtk.Frame):
     """A frame containing the information about a single fault.
 
@@ -26,21 +26,18 @@
     def __init__(self, faultText):
         """Construct the frame."""
-        gtk.Frame.__init__(self)
+        Gtk.Frame.__init__(self)
 
         self._faultText = faultText
 
-        vbox = gtk.VBox()
-
-        self._fault = fault = gtk.TextView()
-        fault.set_editable(False)
-        fault.set_can_focus(False)
-        fault.set_wrap_mode(WRAP_WORD)
-
-        buffer = fault.get_buffer()
-        self._faultTag  = buffer.create_tag("fault", weight=WEIGHT_BOLD)
+        vbox = Gtk.VBox()
+
+        self._fault = fault = Gtk.Label()
+        fault.set_xalign(0.0)
+        fault.set_justify(Gtk.Justification.LEFT)
+        fault.set_line_wrap(True)
 
         self.faultText = faultText
 
-        faultAlignment = gtk.Alignment(xalign = 0.0, yalign = 0.0,
+        faultAlignment = Gtk.Alignment(xalign = 0.0, yalign = 0.0,
                                        xscale = 1.0, yscale = 0.0)
         faultAlignment.set_padding(padding_top = 0, padding_bottom = 0,
@@ -49,6 +46,6 @@
         vbox.pack_start(faultAlignment, True, True, 4)
 
-        self._explanation = explanation = gtk.TextView()
-        explanation.set_wrap_mode(WRAP_WORD)
+        self._explanation = explanation = Gtk.TextView()
+        explanation.set_wrap_mode(Gtk.WrapMode.WORD)
         explanation.set_accepts_tab(False)
         explanation.set_size_request(-1, 100)
@@ -62,11 +59,7 @@
         self.show_all()
 
-        if pygobject:
-            styleContext = self.get_style_context()
-            color = styleContext.get_background_color(gtk.StateFlags.NORMAL)
-            fault.override_background_color(0, color)
-        else:
-            style = self.rc_get_style()
-            fault.modify_base(0, style.bg[0])
+        styleContext = self.get_style_context()
+        color = styleContext.get_background_color(Gtk.StateFlags.NORMAL)
+        fault.override_background_color(0, color)
 
         self._hasExplanation = False
@@ -81,9 +74,5 @@
         """Update the text of the fault."""
         self._faultText = faultText
-
-        buffer = self._fault.get_buffer()
-        buffer.set_text(faultText)
-        buffer.apply_tag(self._faultTag,
-                         buffer.get_start_iter(), buffer.get_end_iter())
+        self._fault.set_markup("<b>" + faultText + "</b>")
 
     @property
@@ -125,10 +114,10 @@
 #-------------------------------------------------------------------------------
 
-gobject.signal_new("explanation-changed", FaultFrame, gobject.SIGNAL_RUN_FIRST,
+GObject.signal_new("explanation-changed", FaultFrame, GObject.SIGNAL_RUN_FIRST,
                    None, (bool,))
 
 #-------------------------------------------------------------------------------
 
-class FaultExplainWidget(gtk.Frame):
+class FaultExplainWidget(Gtk.Frame):
     """The widget for the faults and their explanations."""
     @staticmethod
@@ -138,5 +127,5 @@
 
     def __init__(self, gui):
-        gtk.Frame.__init__(self)
+        Gtk.Frame.__init__(self)
 
         self._gui = gui
@@ -145,16 +134,16 @@
         label.set_use_underline(True)
 
-        alignment = gtk.Alignment(xalign = 0.5, yalign = 0.5,
+        alignment = Gtk.Alignment(xalign = 0.5, yalign = 0.5,
                                   xscale = 1.0, yscale = 1.0)
         alignment.set_padding(padding_top = 4, padding_bottom = 4,
                               padding_left = 4, padding_right = 4)
 
-        self._outerBox = outerBox = gtk.EventBox()
+        self._outerBox = outerBox = Gtk.EventBox()
         outerBox.add(alignment)
 
-        self._innerBox = innerBox = gtk.EventBox()
+        self._innerBox = innerBox = Gtk.EventBox()
         alignment.add(self._innerBox)
 
-        alignment = gtk.Alignment(xalign = 0.5, yalign = 0.5,
+        alignment = Gtk.Alignment(xalign = 0.5, yalign = 0.5,
                                   xscale = 1.0, yscale = 1.0)
         alignment.set_padding(padding_top = 0, padding_bottom = 0,
@@ -163,11 +152,11 @@
         innerBox.add(alignment)
 
-        scroller = gtk.ScrolledWindow()
-        scroller.set_policy(POLICY_AUTOMATIC, POLICY_AUTOMATIC)
-        scroller.set_shadow_type(SHADOW_NONE)
-
-        self._faults = gtk.VBox()
+        scroller = Gtk.ScrolledWindow()
+        scroller.set_policy(Gtk.PolicyType.AUTOMATIC, Gtk.PolicyType.AUTOMATIC)
+        scroller.set_shadow_type(Gtk.ShadowType.NONE)
+
+        self._faults = Gtk.VBox()
         self._faults.set_homogeneous(False)
-        scroller.add_with_viewport(self._faults)
+        scroller.add(self._faults)
 
         alignment.add(scroller)
@@ -200,5 +189,5 @@
         """Add a fault with the given ID and text."""
 
-        alignment = gtk.Alignment(xalign = 0.0, yalign = 0.0,
+        alignment = Gtk.Alignment(xalign = 0.0, yalign = 0.0,
                                       xscale = 1.0, yscale = 0.0)
         alignment.set_padding(padding_top = 2, padding_bottom = 2,
@@ -247,5 +236,5 @@
     def reset(self):
         """Reset the widget by removing all faults."""
-        for (alignment, faultFrame) in self._faultWidgets.itervalues():
+        for (alignment, faultFrame) in self._faultWidgets.values():
             self._faults.remove(alignment)
         self._faults.show_all()
@@ -292,24 +281,20 @@
         not."""
         allExplained = self._numExplanations >= self._numFaults
-        if pygobject:
-            styleContext = self.get_style_context()
-            if allExplained:
-                outerColour = innerColour = gdk.RGBA(red = 0.0, green=0.0,
-                                                     blue=0.0, alpha=0.0)
-            else:
-                outerColour = \
-                  styleContext.get_background_color(gtk.StateFlags.SELECTED)
-                innerColour = self._gui.backgroundColour
-
-            self._outerBox.override_background_color(gtk.StateFlags.NORMAL,
-                                                     outerColour)
-            self._innerBox.override_background_color(gtk.StateFlags.NORMAL,
-                                                     innerColour)
+        styleContext = self.get_style_context()
+        if allExplained:
+            outerColour = innerColour = Gdk.RGBA(red = 0.0, green=0.0,
+                                                 blue=0.0, alpha=0.0)
         else:
-            style = self.rc_get_style()
-            self._outerBox.modify_bg(0, style.bg[0 if allExplained else 3])
-
-#-------------------------------------------------------------------------------
-
-gobject.signal_new("explanations-changed", FaultExplainWidget,
-                   gobject.SIGNAL_RUN_FIRST, None, (bool,))
+            outerColour = \
+                styleContext.get_border_color(Gtk.StateFlags.DROP_ACTIVE)
+            innerColour = self._gui.backgroundColour
+
+        self._outerBox.override_background_color(Gtk.StateFlags.NORMAL,
+                                                 outerColour)
+        self._innerBox.override_background_color(Gtk.StateFlags.NORMAL,
+                                                 innerColour)
+
+#-------------------------------------------------------------------------------
+
+GObject.signal_new("explanations-changed", FaultExplainWidget,
+                   GObject.SIGNAL_RUN_FIRST, None, (bool,))
